#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const fixture_class_js_1 = require("../tests/fixtures/fixture-class.js");
const instance_to_class_js_1 = require("./instance-to-class.js");
(0, tstest_1.test)('instanceToClass smoke testing', async (t) => {
    const instance = new fixture_class_js_1.FixtureClass(1, 2);
    const SameFixtureClass = (0, instance_to_class_js_1.instanceToClass)(instance, fixture_class_js_1.FixtureClass);
    t.equal(SameFixtureClass, fixture_class_js_1.FixtureClass, 'should get back the same Class for its own instance');
    class ChildFixtureClass extends fixture_class_js_1.FixtureClass {
    }
    const anotherInstance = new ChildFixtureClass(3, 4);
    const AnotherFixtureClass = (0, instance_to_class_js_1.instanceToClass)(anotherInstance, fixture_class_js_1.FixtureClass);
    t.not(AnotherFixtureClass, fixture_class_js_1.FixtureClass, 'should get back another Class for instance from its child class');
});
//# sourceMappingURL=instance-to-class.spec.js.map